﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;

namespace MyECULib
{
    public class MyECUDataDispatcher
    {
        public Thread readThread;
        private List<MyECUDataObserver> observers = new List<MyECUDataObserver>();
        public MyECUSource source;
        public bool quitting = false;

        public MyECUDataDispatcher(MyECUSource _source)
        {
            source = _source;
            readThread = new Thread(startProcessing);
        }

        private void dataRecieved(MyECUData data)
        {
            foreach (MyECUDataObserver observer in observers)
            {
                observer.MyECUSourceUpdate(data);
            }
        }

        private void dataClosed()
        {
            foreach (MyECUDataObserver observer in observers)
            {
                observer.MyECUSourceClosed();
            }
        }

        public void addObserver(MyECUDataObserver observer)
        {
            observers.Add(observer);
        }

        public void startup()
        {
            readThread.Start(this);
        }

        public void stop()
        {
            quitting = true;
        }

        protected void BlockingReadLine()
        {
            while (quitting == false && source.isOpen())
            {
                MyECUData data = source.GetECUdata();
                dataRecieved(data);
            }
        }

        private static void startProcessing(object data)
        {
            MyECUDataDispatcher disp = (MyECUDataDispatcher)data;
                disp.BlockingReadLine();
        }

    }
}
